
#include "StateContext.h"
#include "StateChanger.h"
#include "StateFactory.h"
#include "Actions.h"

#include "StateClasses.h"

void Day::Dark ()
{
    context.changer.ChangeState(context.factory.OffState());
}

void Night::Light ()
{
    context.actions.LampOff();
    context.changer.ChangeState(context.factory.DayState());
}

void Off::Movement ()
{
    context.actions.LampOn();
    context.changer.ChangeState(context.factory.MovingState());
}

void Moving::NoMovement ()
{
    context.actions.StartTimer();
    context.changer.ChangeState(context.factory.TimingState());
}

void Timing::Timeout ()
{
    context.actions.LampOff();
    context.changer.ChangeState(context.factory.OffState());
}

void Timing::Movement ()
{
    context.changer.ChangeState(context.factory.MovingState());
}
