#ifndef STATE_FACTORY_H
#define STATE_FACTORY_H

class State;

//------------------------------------------------------------------------------
//
class StateFactory
//
/// @brief Interface describing something which supplies State objects.
///
//------------------------------------------------------------------------------
{
public:

    virtual ~StateFactory () {};

    virtual State & DayState () = 0;
    virtual State & OffState () = 0;
    virtual State & MovingState () = 0;
    virtual State & TimingState () = 0;

};
#endif // STATE_FACTORY_H
